#!/usr/bin/python -tt
# Basic functional exercises
# Fill in the code for the functions below. main() is already set up
# to call the functions with a few different inputs,
# printing 'OK' when each function is correct.
# The starter code for each function includes a 'return'
# which is just a placeholder for your code.

# A. concat
# Write a function that, given a list l of lists, 
# concatenates all the lists together. 
# It should be implemented with a combination of map(),filter(),reduce()
# or list comprehnsions
# Example: concat (['a','b','c'], ['d','e','f'], ['g'], ['h','i'] ]) ->  ['a','b','c','d','e','f','g','h','i'] 
def concat(l):
  # +++your code here+++
  return

# B. group
# Write a function that, given a list l of key/value pairs (tuples),
# outputs a list of tuples, where each sublist is of the form (key, [v1, v2,...]).
# There are two possible implementations; one uses a dictinary and one does not.
# It should be implemented with a combination of map(),filter(),reduce()
# or list comprehnsions
# Example: group([ (k1,a), (k2,b), (k1,c), (k1,d), (k3,e), (k2,f) ]) -> [ (k1,[a,c,d]), (k2,[b,f]), (k3,[e]) ] 
def group(l):
  # +++your code here+++
  return
  
# C. partition
# Write a function that, given a list of integers and a value k,
# can be folded over the list such that the result of the fold is two lists partitioned around the value k.
# Feel free to hardcode the value k in function f. 
# Example: Let k = 3. partition([8,2,6,1,3,6,2,0]) -> ([2,1,2,0], [3,8,6,6]) 
def partition(l):
  # +++your code here+++
  return


# D. composition
# Given 2 functions f and g, create a third function that is the composition of the two (should be really short). 
# Example: compose(add2, mult10)(2) -> 22 #g*10+2
def compose(f,g):
  # +++your code here+++
  return
 

# Simple provided test() function used in main() to print
# what each function returns vs. what it's supposed to return.
def test(got, expected):
  if got == expected:
    prefix = ' OK '
  else:
    prefix = '  X '
  print '%s got: %s expected: %s' % (prefix, repr(got), repr(expected))


# Calls the above functions with interesting inputs.
def main():
  print 'concat'
  # Each line calls concat, compares its result to the expected for that call.
  test(concat([ ['a','b','c'], ['d','e','f'], ['g'], ['h','i'] ]),  ['a','b','c','d','e','f','g','h','i'])
  test(concat([ ['a','b','c'], [] ]),  ['a','b','c'])
  test(concat([ ['a','b'], [['d']] ]),  ['a','b',['d']])
  test(concat([ [1,2], [2,3,4],[5,6] ]), [1,2,2,3,4,5,6])
  
  print
  print 'group'
  test(group([ ('k1','a'), ('k2','b'), ('k1','c'), ('k1','d'), ('k3','e'), ('k2','f') ]), [ ('k1',['a','c','d']), ('k2',['b','f']), ('k3',['e']) ])

  
  print
  print 'partition'
  test(partition([8,2,6,1,3,6,2,0]), ([2,1,2,0], [8,6,6,3]))
  test(partition([8,12,6,11,13,6,12,3]), ([], [8,12,6,11,13,6,12,3]))
  
  print
  print 'compose'
  add2 = lambda x: x+2
  mult10 = lambda x: x*10
  f = compose(add2, mult10)
  test(f(2), 22)
  
if __name__ == '__main__':
  main()
